#!/usr/bin/perl
#
# Pu-roxy
#
# (c) FukTommy <fuktommy@inter7.jp>
#
# Released under the GNU General Public License
#

use Pu::Config;
use Pu::Document;
use Pu::System;
use Pu::Post;
use CGI;

$ENV{LANG}="C";
open STDERR, "> /dev/null" if (-w "/dev/null");

# ǰΤPOSTΤȤƤФƤ
if ($ENV{REQUEST_METHOD} eq "POST") {
	read(STDIN,$content_post,$ENV{CONTENT_LENGTH});
}

# ɤURL򻲾ȤΤޤåιϤΤ
$cgi = new CGI();
$mode = $cgi->url_param('mode');
$url = $cgi->url_param('url');
$pu = $cgi->script_name();
$url = $ENV{QUERY_STRING} if (($mode eq "")&&($url eq ""));

# ԤϽ񤭹ʤ
# åȤʤ
if ((($mode =~ /post/)||($mode eq "cache")||($mode eq "tcache"))
	&& ($cgi->remote_host() !~ /$Pu::Config::arrowHost/)) {
	Pu::Document::cm();
	exit;
}

# ɬפʤflock
mkdir $Pu::Config::cacheDir, 0700 unless (-d $Pu::Config::cacheDir);
umask $Pu::Config::umask;
if ($Pu::Config::lockMode) {
	open LOCK, "> " . $Pu::Config::cacheDir . "/lock";
	unless (flock LOCK, $Pu::Config::lockMode) {
		Pu::Document::cm();
		exit;
	}
}

# ̤ʥ⡼ɤư
if ($mode eq "cm") {			# 
	Pu::Document::cm();
	exit;
} elsif ($mode eq "menu") {		# ˥塼
	Pu::System::get($Pu::Config::menuURL);
	Pu::System::printMenu($Pu::Config::menuURL);
	exit;
} elsif ($mode eq "cache") {		# å(ե̾ǥ)
	Pu::System::cache(sort=>"file");
	exit;
} elsif ($mode eq "tcache") {		# å(ǥ)
	Pu::System::cache(sort=>"stamp");
	exit;
} elsif ($mode eq "post") {		# 񤭹߽
	Pu::Post::postWindow($url);
	exit;
} elsif ($mode eq "realpost") {		# 񤭹
	Pu::Post::makeDataAndPost($url, $content_post);
	exit;
}

# URL줾ФƤư
if ($url eq "") {			# ˥塼
	Pu::System::get($Pu::Config::menuURL);
	Pu::System::printMenu($Pu::Config::menuURL);
	exit;
} elsif ($url =~ m|^[^/]+/[^/]+/$|) {	# 
	Pu::System::get("$url/subject.txt");
	Pu::System::printSubject("$url/subject.txt");
	exit;
} elsif ($url =~ m|\.dat$|) {		# 
	if ($mode eq "update") {
		Pu::System::update($url);
	} else {
		Pu::System::sync($url);
	}
	Pu::System::printDat($url);
	exit;
} elsif ($url =~ m|read\.cgi|) {	# 
	$url =~ s|http://||;
	$url =~ s|test/read.cgi/||;
	$url =~ s|/[^/]*$||;
	$url =~ s|\d+$|dat/$&.dat|;
	if ($mode eq "update") {
		Pu::System::update($url);
	} else {
		Pu::System::sync($url);
	}
	Pu::System::printDat($url);
	exit;
} else {				# ƥ
	Pu::Document::printHeader("");
	print "<BODY><P><A href='$url'>$url</A><P></BODY></HTML>\n";
	exit;
}

Pu::Document::cm();
exit;
